/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.pythoncodecompleter;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.KeyEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.JTextComponent;
import org.netbeans.api.editor.completion.Completion;
import org.netbeans.spi.editor.completion.CompletionItem;
import org.netbeans.spi.editor.completion.CompletionTask;
import org.netbeans.spi.editor.completion.support.CompletionUtilities;
import org.netbeans.translationserver.TranslationResult;

/**
 *
 * @author yury
 */
public class PythonCompletionItem implements CompletionItem {

    private final TranslationResult result;
    private final int dotOffset;
    
    public PythonCompletionItem(TranslationResult result, int dotOffset) {
        this.result = result;
        this.dotOffset = dotOffset;
    }
    
    @Override
    public void defaultAction(JTextComponent jtc) {
        Document doc = jtc.getDocument();
        int currentOffset = jtc.getCaretPosition();
        try {
            doc.remove(dotOffset + 1, currentOffset - dotOffset - 1);
            doc.insertString(dotOffset + 1, result.getTgt() + "()", null);
            jtc.setCaretPosition(dotOffset + result.getTgt().length() + 2);
            Completion.get().hideAll();
        } catch (BadLocationException ble) {
            Logger.getLogger(PythonCompletionItem.class.getName()).log(Level.SEVERE, "Invalid document position!");
        }
    }

    @Override
    public void processKeyEvent(KeyEvent ke) {
    }

    @Override
    public int getPreferredWidth(Graphics graphics, Font font) {
        return CompletionUtilities.getPreferredWidth(result.getTgt(), null, graphics, font);
    }

    @Override
    public void render(Graphics grphcs, Font font, Color color, Color color1, int i, int i1, boolean bln) {
        String methodName = result.getTgt();
        CompletionUtilities.renderHtml(new ImageIcon("icons/python.png"), methodName, methodName, grphcs, font, color, i1, i1, bln);
    }

    @Override
    public CompletionTask createDocumentationTask() {
        return null;
    }

    @Override
    public CompletionTask createToolTipTask() {
        return null;
    }

    @Override
    public boolean instantSubstitution(JTextComponent jtc) {
        return false;
    }

    @Override
    public int getSortPriority() {
        return (int) -(Math.floor(result.getPred_score()));
    }

    @Override
    public CharSequence getSortText() {
        return result.getTgt();
    }

    @Override
    public CharSequence getInsertPrefix() {
       return result.getTgt();
    }
    
}
