/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.utils;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author yury
 */
public class TextProcessingUtils {
    
    /**
     * Uses python nltk word_tokenize() function in order to tokenize text 
     * @param sentence
     * @return List<String> representing list of tokens. In case of error, returns null. 
     */
    public static String tokenize(String sentence) {
        if (sentence.isEmpty()) {
            return "";
        }
        try {
            ProcessBuilder builder = new ProcessBuilder("python", "python-utils/my_tokenize.py", sentence);
            builder.redirectErrorStream(true);
            Process tokenizerProcess = builder.start();
            InputStream stdout = tokenizerProcess.getInputStream();
            BufferedReader reader = new BufferedReader(new InputStreamReader(stdout));
            return reader.readLine();
        } catch (Exception e) {
            Logger.getLogger(TextProcessingUtils.class.getName()).log(Level.SEVERE, null, e);
            return null;
        }
    }

}
