import sys
from random import randint

# src_file_path - path to source training data file
# tgt_file_path - path to target training data file
# num_lines - number of lines to extract into validation files
def main(src_file_path, tgt_file_path, num_lines):
    src_file = open(src_file_path, "r")
    tgt_file = open(tgt_file_path, "r")
    if int(num_lines) > 0:
        src_file_lines = src_file.read().splitlines(keepends=True)
        tgt_file_lines = tgt_file.read().splitlines(keepends=True)
        src_file_num_lines = len(src_file_lines)
        tgt_file_num_lines = len(tgt_file_lines)
        print('{file} has total of {num_lines} number of lines'.format(file=src_file_path, num_lines=str(src_file_num_lines)))
        print('{file} has total of {num_lines} number of lines'.format(file=tgt_file_path, num_lines=str(tgt_file_num_lines)))
        if src_file_num_lines == tgt_file_num_lines and src_file_num_lines > 0 and int(num_lines) < src_file_num_lines:
            src_valid_file = open("src-eval.txt", "w+")
            tgt_valid_file = open("tgt-eval.txt", "w+")
            random_line_indexes = []
            for i in range(0, int(num_lines)):
                random_index = randint(0, src_file_num_lines-1)
                random_line_indexes.append(random_index)
            print('Generated {num_lines} random indexes!'.format(num_lines=num_lines))
            for random_line_index in random_line_indexes:
                src_file_line = src_file_lines[random_line_index]
                tgt_file_line = tgt_file_lines[random_line_index]
                src_valid_file.write(src_file_line)
                tgt_valid_file.write(tgt_file_line)
            print('Prepared validation files!')
            for random_line_index in sorted(random_line_indexes, reverse=True):
                del src_file_lines[random_line_index]
                del tgt_file_lines[random_line_index]
            print('Re-writing source and target training files...')
            with open(src_file_path, "w") as updated_src_file:
                for src_file_line in src_file_lines:
                    updated_src_file.write(src_file_line)
                updated_src_file.close()
            with open(tgt_file_path, "w") as updated_tgt_file:
                for tgt_file_line in tgt_file_lines:
                    updated_tgt_file.write(tgt_file_line)
                updated_tgt_file.close()

            src_valid_file.close()
            tgt_valid_file.close()
        else:
            if src_file_num_lines != tgt_file_num_lines:
                print('Number of lines in {src_file} doesn\'t match number of lines in {tgt_file}! Exiting...'.format(src_file=src_file, tgt_file=tgt_file))
            elif src_file_num_lines == 0:
                print('{src_file} and {tgt_file} are empty! Exiting...'.format(src_file=src_file, tgt_file=tgt_file))
            else:
                print('Specified number of lines for validation file isn\'t valid! Exiting...')
            sys.exit(0)
    else:
        print('\'num_lines\' should be a positive number! Exiting...')
        sys.exit(0)

    src_file.close()
    tgt_file.close()
    print("Finished!")

if __name__ == "__main__":
    main(sys.argv[1], sys.argv[2], sys.argv[3])