import os
import sys
import zipfile
import tarfile

#extracts only .py files from .zip archive into same directory
def extract_zipfile(filename):
    try:
        zip_file = zipfile.ZipFile(filename, 'r')
        directory = './extracted'
        [zip_file.extract(file, directory) for file in zip_file.namelist() if file.endswith('.py')]
        zip_file.close()
    except IOError as ioErr:
        print("I/O error processsing", filename, ioErr.strerror)

#returns all .py files given information about 'tar' archive members
def py_files(members):
    for tarinfo in members:
        if os.path.splitext(tarinfo.name)[1] == ".py":
            yield tarinfo

#extracts only .py files from .tar archive into same directory
def extract_tarfile(filename):
    try:
        tar = tarfile.open(filename)
        tar.extractall(path="./extracted", members=py_files(tar))
        tar.close()
    except IOError as ioErr:
        print("I/O error processsing", filename, ioErr.strerror)
    except tarfile.ReadError:
        print("Error reading file", filename)

#collects all filenames in given path
def collect_filenames(path):
    files = []
    for (dirpath, dirnames, filenames) in os.walk(path):
        files.extend(filenames)
        break
    return files

def main(path):
    filenames = collect_filenames(path)
    print("Collected files:", len(filenames))
    counter = 1
    for filename in filenames:
        print("Prcesssing", filename, "...")
        if ".tar." in filename:
            extract_tarfile(path+"/"+filename)
        elif ".zip" in filename:
            extract_zipfile(path+"/"+filename)
        else:
            print("Unknown file format:", filename)
        print("Processed", counter, "files out of", len(filenames))
        counter+=1

if __name__ == "__main__":
    main(sys.argv[1])