from scrapy.contrib.spiders import CrawlSpider
from scrapy.http import Request

# crawling spider
class PypiSpider(CrawlSpider):

    #spider configuration
    name = "pypi"
    start_urls = ["https://pypi.python.org/simple/"]
    total_packages = 0
    src_file = open("links.txt", "w+")

    def parse(self, response):
        all_links = response.xpath('//@href').extract()
        print("Extracted total of links:", len(all_links))
        for link in all_links:
            package_link = self.start_urls[0] + link
            yield Request(url=package_link, callback=self.download_package, dont_filter=True)
        print("Collected total of links:", self.total_packages)

    def download_package(self, response):
        #extract available package names only with *.zip and *.tar.* extensions
        package_names = response.xpath('//a[contains(text(),\'.tar.\') or contains(text(),\'.zip\')]/text()').extract()
        if package_names is not None and len(package_names) > 0:
            #sort packages in descending order so newest version comes first
            package_names.sort(reverse=True)

            #extracting url of the package using it's name
            download_url = response.xpath('//a[text() = \'' + package_names[0] + '\']/@href').extract()
            download_url = self.start_urls[0] + download_url[0]
            print("Added link to package: ", download_url, "...")
            self.total_packages += 1

            self.src_file.write(download_url)
            self.src_file.write("\n")


