# amount of relevant content = large
# closeness of context = far
# good naming = yes
# built-in types = yes
import socket
import sys

def socket_example():
    # Create a TCP/IP socket
    sock = socket.create_connection(('localhost', 10000))

    try:

        message = 'This is the message.  It will be repeated.'
        sock.sendall(message)

        # sending a message using a socket
        print >> sys.stderr, 'sending "%s"' % message


        # auxilary function
        def get_constants(prefix):

            """Create a dictionary mapping socket module constants to their names."""
            return dict((getattr(socket, n), n)
                    for n in dir(socket)
                    if n.startswith(prefix)
                    )

        amount_received = 0
        amount_expected = len(message)

        while amount_received < amount_expected:
            data = sock.recv(16)
            amount_received += len(data)
            print >> sys.stderr, 'received "%s"' % data

            # defines families, values and protocols
            families = get_constants('AF_')
            types = get_constants('SOCK_')
            protocols = get_constants('IPPROTO_')

            # prints information about socket
            print >> sys.stderr, 'Family  :', families[sock.family]
            print >> sys.stderr, 'Type    :', types[sock.type]
            print >> sys.stderr, 'Protocol:', protocols[sock.proto]
            print >> sys.stderr

    finally:
        print >> sys.stderr, 'closing socket'
        sock.close() <completion>
