# amount of relevant content = large
# closeness of context = far
# good naming = no
# built-in types = yes
import os
import ast
from textutils import tokenize
from astutils import CallVisitor, PyCompileError
import codecs

def process_file(i_fl):
    try:
        with codecs.open(i_fl, 'r', encoding='utf-8', errors='ignore') as f:
            i_lns = []
            e_lns = []

            fl = f.read()
            lns = fl.splitlines()
            try:
                tr = ast.parse(fl)

                # visit all call nodes in the class
                c_vstr = CallVisitor()
                try:
                    c_vstr.visit(tr)
                    c_nds = c_vstr.call_nodes
                    for (c_nm, ce_nm, nd) in c_nds:
                        # node.lineno is 1-indexed
                        ln_num = nd.lineno - 1
                        cd_ln = lns[ln_num]
                        # get part of the code line before method call i.e. result = node.get(...) returns result = node
                        pr_cd_ln = cd_ln[0:(cd_ln.index(c_nm + ".") + len(c_nm))]
                        i_ln = tokenize(pr_cd_ln)
                        # filter out all self to don't confuse the model
                        i_ln = i_ln.replace("self ", "")
                        i_ln += "\n"
                        i_lns.append(i_ln)
                        e_lns.append(ce_nm + "\n")
                except RuntimeError as ru_er:
                    print("Error processing file: ", i_fl + ": ", ru_er)
                    return [], []

            except (PyCompileError, SyntaxError, ValueError, TypeError):
                print("Failed parsing file:", i_fl)
                pass

            f.close() <completion>

            return i_lns, e_lns
    except IOError as ioError:
        print("I/O error processing file", i_fl, ioError.strerror)
        return [], []
