# amount of relevant content = large
# closeness of context = far
# good naming = no
# built-in types = no
import bs4
import nltk
from readability.readability import Document

TAGS = ["<div>", "<href>"]

def preprocess(ph):
    with open(ph, 'r') as f:

        # Transform the document into a readability paper summary
        h = Document(f.read()).summary()

        # Parse the HTML using BeautifulSoup
        sp = bs4.BeautifulSoup(h)

        # Extract the paragraph delimiting elements
        for t in sp.find_all(TAGS):

            # Get the HTML node text
            pg = t.get_text()  # Sentence Tokenize
            snts = nltk.sent_tokenize(ph)
            for idx, snt in enumerate(snts):
                # Word Tokenize and Part of Speech Tagging
                snts[idx] = nltk.pos_tag(nltk.word_tokenize(snt))

                # Yield a list of sentences (the paragraph); each sentence of
                # which is a list of tuples in the form (token, tag).
            yield snts

    print(sp.prettify()) <completion>
