# amount of relevant content = small
# closeness of context = far
# good naming = yes
# built-in types = yes
import re
import html
import ast

def _find_code_in_html(s):
    answers = re.findall(r'<div id="answer-.*?</table', s, re.DOTALL)  # come get me, Zalgo

    def votecount(x):
        """
        Return the negative number of votes a question has.
        Might return the negative question id instead if its less than 100k. That's a feature.
        """
        r = int(re.search(r"\D(\d{1,5})\D", x).group(1))
        return -r

    for answer in sorted(answers, key=votecount):
        codez = re.finditer(r"<pre[^>]*>[^<]*<code[^>]*>((?:\s|[^<]|<span[^>]*>[^<]+</span>)*)</code></pre>", answer)
        codez = map(lambda x: x.group(1), codez)
        for code in sorted(codez, key=lambda x: -len(x)):  # more code is obviously better
            # don't forget attribution
            author = s
            author = author[author.find(code):]
            author = author[:author.find(">share<")]
            author = author[author.rfind('<a href="') + len('<a href="'):]
            author_link = author[:author.find('"'):]
            author_link = "https://stackoverflow.com" + author_link

            # fetch that code
            code = html.unescape(code)
            code = re.sub(r"<[^>]+>([^<]*)<[^>]*>", "\1", code)
            try:
                ast.parse(code)
                return code, author_link  # it compiled! uhm, parsed!
            except:
                pass
    else:  # https://stackoverflow.com/questions/9979970/why-does-python-use-else-after-for-and-while-loops
        raise ImportError("This question ain't got no good code.")

    answers.reverse() <completion>
